//
// res2csv.cpp
//
// Utilitaire de conversion des fichiers rsultats de Trajec
//
// Compil avec Microsoft Visual C++ 6.0
//


#include "stdafx.h"
//#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <io.h>
//#include <conio.h>

//---------------------------------------------------------------------------
// Structure des donnes du fichier binaire .res trajec
struct ligne
{
    long     int t;	    // Temps
    unsigned int v;     // Vitesse
    unsigned int z;	    // Altitude
    unsigned int g;	    // Acclration
    unsigned int a;     // Angle (incidence)
    unsigned int x;     // Position en X
    unsigned int y;	    // Position en Y
    bool Fpara;			// para ouvert
    bool Frampe;		// sortie de rampe
    bool Fprop;			// fin de propulsion
    bool Fouv;			// ouverture para
    bool Fculmi;        // culmination
};



//---------------------------------------------------------------------------
int main ()
{
	char NomFusee[20], FichierRes[20], FichierCsv[20];
	ligne donnee;

	printf("\n\nres2csv.exe\n\n");
	printf("Utilitaire qui convertit un fichier resultat de Trajec\n");
	printf("\t\t\t en fichier csv importable sous Excel.\n\n");
	printf("Entree : fichier ?.res  (fichier binaire)\n");
	printf("Sortie : fichier ?.csv  (fichier texte) donnees separees par point-virgules\n");
	printf("\n\n");

	// Acquisition du nom du fichier  convertir
	printf("Entrez ci-dessous le nom '?' du fichier ?.res a convertir.\n");
	printf("Attention : si le nom contient des accents,\n");
	printf("            alors il faut utiliser le nom au format 8.3 DOS.\n");
	printf("            Utiliser la commande DOS 'dir /X' pour trouver le nom DOS\n");
	printf("            Par exemple : Clopat~1  pour  Clopatr  \n");
	printf("\nnom : ");
	
	gets(NomFusee); printf("\n");
	strcpy( FichierRes, NomFusee);
	strcat( FichierRes, ".res" );
	strcpy( FichierCsv, NomFusee);
	strcat( FichierCsv, ".csv" );

    // Ouverture fichier source
    FILE *fsource=fopen(FichierRes, "rb");
    if(fsource==NULL)
    {	printf("\nERREUR : Fichier d'entree '%s' inexistant\n", FichierRes);
		printf("L'utilitaire res2csv.exe doit etre place \ndans le meme repertoire que les fichiers Trajec.\n");
        gets(NomFusee); exit(-1);
    }

    // Cration fichier destination
    FILE *fdest=fopen(FichierCsv, "wt");
    if(fdest==NULL)
    {   printf("\nERREUR : Impossible de creer ou modifier le fichier de sortie '%s'\n",FichierCsv);
		printf("Verifiez qu'il n'est pas ouvert par Excel actuellement !\n");
		printf("L'utilitaire res2csv.exe doit etre place \ndans le meme repertoire que les fichiers Trajec.\n");
        gets(NomFusee); exit(-1);
    }


	// Ecriture du fichier csv
	// En-tte :
	fprintf(fdest, ";Temps; Altitude relative; Vitesse; Position en X; Position en Y; Acclration (charge totale); Angle /horiz\n");
    fprintf(fdest, ";1/100e de s ; m; m/s; m; m; m/s^2; \n");
	fprintf(fdest, ";t; z; v; x; y; g; a\n");

    // Boucle jusqu' la fin du fichier source
    while (!feof(fsource))
	{
		fscanf(fsource, "%33c",&donnee);

				if (donnee.Fouv)	fprintf(fdest,"Ouverture parachute");
		else	if (donnee.Fculmi)	fprintf(fdest,"Culmination");
		else	if (donnee.Frampe)	fprintf(fdest,"Sortie de rampe");
		else	if (donnee.Fprop)	fprintf(fdest,"Fin de propulsion");
		else	{
					printf("t:%d, z:%d, v:%d, z:%d, v:%d, g:%d, a:%d \n",donnee.t, donnee.z, donnee.v, donnee.x, donnee.y, donnee.g, donnee.a);
					fprintf(fdest,";%d; %d; %d; %d; %d; %d; %d \n",      donnee.t, donnee.z, donnee.v, donnee.x, donnee.y, donnee.g, donnee.a);
				}
    };

    // Fermer les fichiers
    fclose(fdest);
    fclose(fsource);
	
	printf("\nFin de la lecture du fichier  '%s'",FichierRes);
	printf("\nFin de l'ecriture du fichier  '%s'",FichierCsv);
	printf("\nVous pouvez maintenant ouvrir '%s' avec Excel ;-)\n\n",FichierCsv);
	
    gets(NomFusee); return 0;
}
 